Package org.apache.commons.io.function

# Interface IOFunction<T,R>

Type Parameters:
  `T` - the type of the input to the operations.
  `R` - the return type of the operations.

All Known Subinterfaces:
  `IOUnaryOperator<T>`

Functional Interface:
  This is a functional interface and can therefore be used as the assignment target for a lambda expression or method reference.

@FunctionalInterface public interface IOFunction<T,R>
Like `Function` but throws `IOException`.

Since:
  2.7

- ## Method Summary

  Modifier and Type
  Method
  Description
  `default IOConsumer<T>`
  `andThen(Consumer<? super R> after)`
  Returns a composed `IOFunction` that first applies this function to its input, and then applies the `after` consumer to the result.
  `default <V> IOFunction<T,V>`
  `andThen(Function<? super R,? extends V> after)`
  Returns a composed `IOFunction` that first applies this function to its input, and then applies the `after` function to the result.
  `default IOConsumer<T>`
  `andThen(IOConsumer<? super R> after)`
  Returns a composed `IOFunction` that first applies this function to its input, and then applies the `after` consumer to the result.
  `default <V> IOFunction<T,V>`
  `andThen(IOFunction<? super R,? extends V> after)`
  Returns a composed `IOFunction` that first applies this function to its input, and then applies the `after` function to the result.
  `R`
  `apply(T t)`
  Applies this function to the given argument.
  `default Function<T,R>`
  `asFunction()`
  Creates a `Function` for this instance that throws `UncheckedIOException` instead of `IOException`.
  `default <V> IOFunction<V,R>`
  `compose(Function<? super V,? extends T> before)`
  Returns a composed `IOFunction` that first applies the `before` function to its input, and then applies this function to the result.
  `default IOSupplier<R>`
  `compose(Supplier<? extends T> before)`
  Returns a composed `IOFunction` that first applies the `before` function to its input, and then applies this function to the result.
  `default <V> IOFunction<V,R>`
  `compose(IOFunction<? super V,? extends T> before)`
  Returns a composed `IOFunction` that first applies the `before` function to its input, and then applies this function to the result.
  `default IOSupplier<R>`
  `compose(IOSupplier<? extends T> before)`
  Returns a composed `IOFunction` that first applies the `before` function to its input, and then applies this function to the result.
  `static <T> IOFunction<T,T>`
  `identity()`
  Returns a `IOFunction` that always returns its input argument.

- ## Method Details

  - ### identity

    static <T> IOFunction<T,T> identity()
    Returns a `IOFunction` that always returns its input argument.
    Type Parameters:
      `T` - the type of the input and output objects to the function
    Returns:
      a function that always returns its input argument

  - ### andThen

    default IOConsumer<T> andThen(Consumer<? super R> after)
    Returns a composed `IOFunction` that first applies this function to its input, and then applies the `after` consumer to the result. If evaluation of either function throws an exception, it is relayed to the caller of the composed function.
    Parameters:
      `after` - the consumer to apply after this function is applied
    Returns:
      a composed function that first applies this function and then applies the `after` consumer
    Throws:
      `NullPointerException` - if after is null
    See Also:
      - `compose(IOFunction)`

  - ### andThen

    default <V> IOFunction<T,V> andThen(Function<? super R,? extends V> after)
    Returns a composed `IOFunction` that first applies this function to its input, and then applies the `after` function to the result. If evaluation of either function throws an exception, it is relayed to the caller of the composed function.
    Type Parameters:
      `V` - the type of output of the `after` function, and of the composed function
    Parameters:
      `after` - the function to apply after this function is applied
    Returns:
      a composed function that first applies this function and then applies the `after` function
    Throws:
      `NullPointerException` - if after is null
    See Also:
      - `compose(IOFunction)`

  - ### andThen

    default IOConsumer<T> andThen(IOConsumer<? super R> after)
    Returns a composed `IOFunction` that first applies this function to its input, and then applies the `after` consumer to the result. If evaluation of either function throws an exception, it is relayed to the caller of the composed function.
    Parameters:
      `after` - the consumer to apply after this function is applied
    Returns:
      a composed function that first applies this function and then applies the `after` consumer
    Throws:
      `NullPointerException` - if after is null
    See Also:
      - `compose(IOFunction)`

  - ### andThen

    default <V> IOFunction<T,V> andThen(IOFunction<? super R,? extends V> after)
    Returns a composed `IOFunction` that first applies this function to its input, and then applies the `after` function to the result. If evaluation of either function throws an exception, it is relayed to the caller of the composed function.
    Type Parameters:
      `V` - the type of output of the `after` function, and of the composed function
    Parameters:
      `after` - the function to apply after this function is applied
    Returns:
      a composed function that first applies this function and then applies the `after` function
    Throws:
      `NullPointerException` - if after is null
    See Also:
      - `compose(IOFunction)`

  - ### apply

    R apply(T t) throws IOException
    Applies this function to the given argument.
    Parameters:
      `t` - the function argument
    Returns:
      the function result
    Throws:
      `IOException` - if an I/O error occurs.

  - ### asFunction

    default Function<T,R> asFunction()
    Creates a `Function` for this instance that throws `UncheckedIOException` instead of `IOException`.
    Returns:
      an UncheckedIOException Function.
    Since:
      2.12.0

  - ### compose

    default <V> IOFunction<V,R> compose(Function<? super V,? extends T> before)
    Returns a composed `IOFunction` that first applies the `before` function to its input, and then applies this function to the result. If evaluation of either function throws an exception, it is relayed to the caller of the composed function.
    Type Parameters:
      `V` - the type of input to the `before` function, and to the composed function
    Parameters:
      `before` - the function to apply before this function is applied
    Returns:
      a composed function that first applies the `before` function and then applies this function
    Throws:
      `NullPointerException` - if before is null
    See Also:
      - `andThen(IOFunction)`

  - ### compose

    default <V> IOFunction<V,R> compose(IOFunction<? super V,? extends T> before)
    Returns a composed `IOFunction` that first applies the `before` function to its input, and then applies this function to the result. If evaluation of either function throws an exception, it is relayed to the caller of the composed function.
    Type Parameters:
      `V` - the type of input to the `before` function, and to the composed function
    Parameters:
      `before` - the function to apply before this function is applied
    Returns:
      a composed function that first applies the `before` function and then applies this function
    Throws:
      `NullPointerException` - if before is null
    See Also:
      - `andThen(IOFunction)`

  - ### compose

    default IOSupplier<R> compose(IOSupplier<? extends T> before)
    Returns a composed `IOFunction` that first applies the `before` function to its input, and then applies this function to the result. If evaluation of either function throws an exception, it is relayed to the caller of the composed function.
    Parameters:
      `before` - the supplier which feeds the application of this function
    Returns:
      a composed function that first applies the `before` function and then applies this function
    Throws:
      `NullPointerException` - if before is null
    See Also:
      - `andThen(IOFunction)`

  - ### compose

    default IOSupplier<R> compose(Supplier<? extends T> before)
    Returns a composed `IOFunction` that first applies the `before` function to its input, and then applies this function to the result. If evaluation of either function throws an exception, it is relayed to the caller of the composed function.
    Parameters:
      `before` - the supplier which feeds the application of this function
    Returns:
      a composed function that first applies the `before` function and then applies this function
    Throws:
      `NullPointerException` - if before is null
    See Also:
      - `andThen(IOFunction)`